<?php

use Budget\Entity\Account;

$ht = $this->module()->getClientModuleConfiguration('budget', 'ht');
$gbcp = $this->module()->getClientModuleConfiguration('budget', 'gbcp');
$evolution = $this->module()->getClientModuleConfiguration('budget', 'evolution');
$expenseTypes = $this->expenseTypes();
$posteExpenseBalances = $this->posteExpenseBalances();

$groups = [];
if ($this->module()->isActive('keyword')) {
	$groups = $this->allowedKeywordGroups('posteExpense', false);
}

?>

<div ng-controller="posteExpenseListController as self" ng-init="self.init(
         '<?= $this->from ?>',
         <?= $this->object ? $this->object->getId() : 'null' ?>,
         <?= str_replace('"', '\'', json_encode($expenseTypes)) ?>,
         <?= str_replace('"', '\'', json_encode($posteExpenseBalances)) ?>
     )">
	<table-builder options="self.options" items="self.posteExpenses" class="table-builder">
		<div class="row">
			<div class="col-sm-4">
				<div class="table-filters little-panel" ng-controller="filterController">
					<h4 class="separator text-center"><?= ucfirst($this->translate('poste_expense_entity')) ?></h4>
					<div class="title" data-toggle="collapse" href="#filters-collapsed-poste-expenses">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
					</div>
					<div id="filters-collapsed-poste-expenses" class="body collapse">
						<?= $this->tableFilter('__tb.apiParams.search.data.filters', $this->posteExpenseFilters()); ?>
						<div class="row">
							<div class="col-xs-6">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
							</div>
							<div class="col-xs-6 text-right">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
									<?= $this->icon('search', 'fa-fw') ?>
									<?= $this->translate('table_filter_button') ?>
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-sm-4">
				<div class="table-filters little-panel" ng-controller="filterController">
					<h4 class="separator text-center"><?= ucfirst($this->translate('expense_entity')) ?></h4>
					<div class="title" data-toggle="collapse" href="#filters-collapsed-expense">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
					</div>
					<div id="filters-collapsed-expense" class="body collapse">
						<?= $this->tableFilter('self.expenseParams.search.data.filters', $this->expenseFilters()); ?>
						<div class="row">
							<div class="col-xs-6">
								<button class="btn" ng-click="self.resetfullTextSearch(); self.resetExpenseFilters(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
							</div>
							<div class="col-xs-6 text-right">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
									<?= $this->icon('search', 'fa-fw') ?>
									<?= $this->translate('table_filter_button') ?>
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-sm-4">
				<h4 class="separator text-center"><?= ucfirst($this->translate('columns')) ?></h4>
				<table-builder-columns></table-builder-columns>
			</div>
		</div>
		<div class="row" ng-show="showChart">
			<div class="col-xs-12">
				<nvd3 options="chart.options" data="chart.data" api="api"></nvd3>
			</div>
		</div>
		<div class="row">
			<div class="col-xs-12">
				<div class="btn-group pull-right">
					<button class="btn btn-lg" ng-click="__tb.removeFromList()" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
						<?= $this->icon('eraser', 'fa-fw pointer') ?>
					</button>
					<button class="btn btn-lg btn-excel" type="button" tooltip="<?= $this->translate('tooltip_export_xls') ?>" ng-click="self.showExportExpenseModal()"> <?= $this->icon('excel', 'fa-fw pointer') ?>
					</button>
				</div>
				<div class="btn-group pull-right">
					<?php if ($this->acl()->isAllowed('budget:e:posteExpenseSimplified:r')) : ?>
						<button type="button" class="btn btn-lg" ng-click="self.openSimplifiedInput()">
							<?= $this->icon('simplifiedInput'); ?>
							<?= $this->translate('poste_expense_simplified_input'); ?>
						</button>
					<?php endif; ?>
					<?php if ($this->acl()->isAllowed('budget:e:posteExpense:c')) : ?>
						<button type="button" class="btn btn-lg" ng-click="self.createPosteExpense()" ng-if="!lockBudget<?= ($this->from === 'project' && $this->acl()->onlyOwned('project:e:project:u') ? ' && self.isManager(' . $this->authStorage()->getUser()->getId() . ')' : '') ?>">
							<?= $this->icon('create') ?>
							{{ <?= $this->module()->isActive('convention') ? 'true' : 'false' ?> && self.object.external ? '<?= $this->translate('poste_subvention_nav_form') ?>' : '<?= $this->translate('poste_expense_nav_form') ?>' }}
						</button>
					<?php endif; ?>
					<button type="button" class="btn btn-lg" ng-click="showChart = !showChart" tooltip="<?= $this->translate('tooltip_show_chart') ?>">
						<i class="fa fa-bar-chart"></i>
					</button>
				</div>
			</div>
		</div>
		<br />
		<div class="row">
			<div class="col-xs-12">
				<form name="posteExpenseForm">
					<div>
						Grouper par :

						<select ng-model="self.groupBy">
						<option ng-value="'poste'"><?= ucfirst($this->translate('expense_field_poste')) ?></option>
							<option ng-value="'tiers'"><?= ucfirst($this->translate('expense_field_tiers')) ?></option>
							<option ng-value="'date'"><?= ucfirst($this->translate('expense_field_date')) ?></option>
							<option ng-value="'anneeExercice'"><?= ucfirst($this->translate('expense_field_anneeExercice')) ?></option>
							<option ng-value="'bordereau'"><?= ucfirst($this->translate('expense_field_bordereau')) ?></option>
							<option ng-value="'mandat'"><?= ucfirst($this->translate('expense_field_mandat')) ?></option>
							<option ng-value="'engagement'"><?= ucfirst($this->translate('expense_field_engagement')) ?></option>
							<option ng-value="'complement'"><?= ucfirst($this->translate('expense_field_complement')) ?></option>
							<option ng-value="'dateFacture'"> <?= ucfirst($this->translate('expense_field_dateFacture')) ?></option>
							<option ng-value="'evolution'"><?= ucfirst($this->translate('expense_field_evolution')) ?></option>
							<?php if ($gbcp) : ?>
								<option ng-value="'gbcp'"><?= ucfirst($this->translate('budget_gbcp_configuration')) ?></option>
							<?php endif ?>
						</select>
					</div>

					<table table-builder-table class="table table-bordered table-condensed table-hover">
						<thead>
							<tr>
								<th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection" /></th>
								<th tb-column tb-name="tree" class="checkbox-column"></th>
								<th tb-column tb-name="account.name" tb-sortable="true" tb-toggle="true">
									<?= $this->translate('poste_expense_field_account') ?>
								</th>

								<?php if ($gbcp) : ?>
									<th tb-column tb-name="nature.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('poste_expense_field_nature') ?>
									</th>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<th tb-column tb-name="organization.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('poste_expense_field_organization') ?>
									</th>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<th tb-column tb-name="destination.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('poste_expense_field_destination') ?>
									</th>
								<?php endif ?>

								<?php if ($this->acl()->isAllowed('budget:e:managementUnit:r')) : ?>
									<th tb-column tb-name="managementUnit.name" tb-sortable="true" tb-toggle="true">
										<?= $this->translate('management_unit_entity') ?>
									</th>
								<?php endif ?>

								<th tb-column tb-name="name" tb-sortable="true" tb-toggle="true">
									<?= $this->translate('poste_expense_field_name') ?>
								</th>
								<th tb-column tb-name="project.name" tb-sortable="true" tb-toggle="true"><?= ucfirst($this->translate('project_entity')) ?></th>

								<?php if ($this->module()->isActive('keyword')) : ?>
									<?php foreach ($groups as $group) : ?>
										<th tb-column tb-name="keyword<?= $group->getId() ?>" tb-toggle="true">
											<?= $group->getName() ?>
										</th>
									<?php endforeach ?>
								<?php endif ?>

								<th tb-column tb-name="amount" tb-sortable="true" tb-toggle="true"><?= $this->translate('poste_expense_field_amount') ?></th>

								<?php if ($ht) : ?>
									<th tb-column tb-name="amountHT" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_expense_field_amountHT') ?></th>
								<?php endif ?>

								<th tb-column tb-name="amountArbo" tb-sortable="false" tb-toggle="true"><?= $this->translate('poste_expense_field_amountArbo') ?></th>

								<?php if ($ht) : ?>
									<th tb-column tb-name="amountHTArbo" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_expense_field_amountHTArbo') ?></th>
								<?php endif ?>

								<th tb-column tb-name="amountAggreg" tb-sortable="false" tb-toggle="true"><?= $this->translate('poste_expense_field_amountAggreg') ?></th>

								<?php if ($ht) : ?>
									<th tb-column tb-name="amountHTAggreg" tb-sortable="false" tb-toggle="true" tb-hidden="true"><?= $this->translate('poste_expense_field_amountHTAggreg') ?></th>
								<?php endif ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (preg_match('/^ae/', $type)) : ?>
										<th tb-column tb-name="computed.amountArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-sortable="true">
											<?= $this->translate('expense_type_' . $type) ?>
										</th>

										<?php if ($ht) : ?>
											<th tb-column tb-name="computed.amountHTArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-hidden="true" tb-sortable="true">
												<?= $this->translate('expense_type_' . $type . '_ht') ?>
											</th>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (preg_match('/^ae/', $balance) && $balance !== 'aeCommittedCpCommittedBalance') : ?>
										<th tb-column tb-name="amountArbo<?= ucfirst($balance) ?>" tb-toggle="true" tooltip="<?= $this->translate('poste_expense_formule_' . $balance) ?>">
											<?= $this->translate('poste_expense_balance_' . $balance) ?>
										</th>

										<?php if ($ht) : ?>
											<th tb-column tb-name="amountHTArbo<?= ucfirst($balance) ?>" tb-toggle="true" tb-hidden="true" tooltip="<?= $this->translate('poste_expense_formule_' . $balance) ?>">
												<?= $this->translate('poste_expense_balance_' . $balance . '_ht') ?>
											</th>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (!preg_match('/^ae/', $type) && !preg_match('/^cp/', $type)) : ?>
										<th tb-column tb-name="computed.amountArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-sortable="true">
											<?= $this->translate('expense_type_' . $type) ?>
										</th>

										<?php if ($ht) : ?>
											<th tb-column tb-name="computed.amountHTArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-hidden="true" tb-sortable="true">
												<?= $this->translate('expense_type_' . $type . '_ht') ?>
											</th>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (!preg_match('/^ae/', $balance) && !preg_match('/^cp/', $balance)) : ?>
										<th tb-column tb-name="amountArbo<?= ucfirst($balance) ?>" tb-toggle="true" tooltip="<?= $this->translate('poste_expense_formule_' . $balance) ?>">
											<?= $this->translate('poste_expense_balance_' . $balance) ?>
										</th>

										<?php if ($ht) : ?>
											<th tb-column tb-name="amountHTArbo<?= ucfirst($balance) ?>" tb-toggle="true" tb-hidden="true" tooltip="<?= $this->translate('poste_expense_formule_' . $balance) ?>">
												<?= $this->translate('poste_expense_balance_' . $balance . '_ht') ?>
											</th>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (preg_match('/^cp/', $type)) : ?>
										<th tb-column tb-name="computed.amountArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-sortable="true">
											<?= $this->translate('expense_type_' . $type) ?>
										</th>

										<?php if ($ht) : ?>
											<th tb-column tb-name="computed.amountHTArbo<?= ucfirst($type) ?>" tb-toggle="true" tb-hidden="true" tb-sortable="true">
												<?= $this->translate('expense_type_' . $type . '_ht') ?>
											</th>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (preg_match('/^cp/', $balance) || $balance === 'aeCommittedCpCommittedBalance') : ?>
										<th tb-column tb-name="amountArbo<?= ucfirst($balance) ?>" tb-toggle="true" tooltip="<?= $this->translate('poste_expense_formule_' . $balance) ?>">
											<?= $this->translate('poste_expense_balance_' . $balance) ?>
										</th>

										<?php if ($ht) : ?>
											<th tb-column tb-name="amountHTArbo<?= ucfirst($balance) ?>" tb-toggle="true" tb-hidden="true" tooltip="<?= $this->translate('poste_expense_formule_' . $balance) ?>">
												<?= $this->translate('poste_expense_balance_' . $balance . '_ht') ?>
											</th>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<th tb-column tb-name="expenses.tiers" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_tiers') ?>
								</th>
								<th tb-column tb-name="expenses.anneeExercice" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_anneeExercice') ?>
								</th>
								<th tb-column tb-name="expenses.bordereau" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_bordereau') ?>
								</th>
								<th tb-column tb-name="expenses.mandat" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_mandat') ?>
								</th>
								<th tb-column tb-name="expenses.engagement" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_engagement') ?>
								</th>
								<th tb-column tb-name="expenses.complement" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_complement') ?>
								</th>
								<th tb-column tb-name="expenses.dateFacture" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_dateFacture') ?>
								</th>
								<th tb-column tb-name="expenses.date" tb-toggle="true" tb-sortable="true">
									<?= $this->translate('expense_field_date') ?>
								</th>

								<?php if ($evolution) : ?>
									<th tb-column tb-name="expenses.evolution" tb-toggle="true">
										<?= $this->translate('expense_field_evolution') ?>
									</th>
								<?php endif ?>

								<th tb-column tb-name="createdAt" tb-sortable="true" tb-toggle="true" tb-hidden="true">
									<?= $this->translate('poste_expense_field_createdAt') ?>
								</th>
								<th tb-column tb-name="updatedAt" tb-sortable="true" tb-toggle="true" tb-hidden="true">
									<?= $this->translate('poste_expense_field_updatedAt') ?>
								</th>
								<th tb-column tb-name="actions" class="actions-column"></th>
							</tr>
						</thead>
						<tbody></tbody>
						<tbody ng-repeat="posteExpense in self.posteExpenses">
							<tr ng-class="{
                                editing: self.editedLine == posteExpense && posteExpense.id != 'total',
                                pointer: self.editedLine !== posteExpense && posteExpense.id != 'total',
                                group: self.editedLine !== posteExpense && posteExpense.id != 'total',
                                footer: posteExpense.id == 'total',
                                dashed: posteExpense.id !== 'total' && posteExpense.project.id !== self.from.id
                            }" ng-click="showPoste = self.editedLine == posteExpense ? showPoste : !showPoste">
								<td><input type="checkbox" ng-model="posteExpense.selected" /></td>
								<td>
									<i class="fa fa-caret-right pointer" ng-class="{'fa-caret-right' : !showPoste, 'fa-caret-down' : showPoste}" ng-show="posteExpense.expensesArbo.length > 0"></i>
								</td>

								<td class="editable">
									<span ng-show="self.editedLine !== posteExpense && posteExpense.id != 'total'">
										<span ng-if="posteExpense.account">
											<?php if ($this->acl()->isAllowed('budget:e:account:r')) : ?>
												<a href="<?= $this->url('budget/account/form') ?>/{{posteExpense.account.id}}">
													{{posteExpense.account.code}} - {{posteExpense.account.name}}
												</a>
											<?php else : ?>
												{{posteExpense.account.code}} - {{posteExpense.account.name}}
											<?php endif ?>
										</span>

										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteExpense">
										<account-select name="account" ng-model="self.editedLineFields.account" form="posteExpenseForm" configuration="{
                                            service: {
                                                apiParams: {
                                                    search: {
                                                        data: {
                                                            filters: {
                                                                type: {
                                                                    op: 'eq',
                                                                    val: '<?= Account::TYPE_EXPENSE ?>'
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }"></account-select>
										<field-errors field="account" errors="self.errors.fields"></field-errors>
									</span>
								</td>

								<?php if ($gbcp) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== posteExpense && posteExpense.id != 'total'">
											<span ng-if="posteExpense.nature">
												<?php if ($this->acl()->isAllowed('budget:e:nature:r')) : ?>
													<a href="<?= $this->url('budget/nature/form') ?>/{{posteExpense.nature.id}}">
														{{posteExpense.nature.name}}
													</a>
												<?php else : ?>
													{{posteExpense.nature.name}}
												<?php endif ?>
											</span>

											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteExpense">
											<nature-select name="nature" ng-model="self.editedLineFields.nature" form="posteExpenseForm"></nature-select>
											<field-errors field="nature" errors="self.errors.fields"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== posteExpense && posteExpense.id != 'total'">
											<span ng-if="posteExpense.organization">
												<?php if ($this->acl()->isAllowed('budget:e:organization:r')) : ?>
													<a href="<?= $this->url('budget/organization/form') ?>/{{posteExpense.organization.id}}">
														{{posteExpense.organization.code}} - {{posteExpense.organization.name}}
													</a>
												<?php else : ?>
													{{posteExpense.organization.code}} - {{posteExpense.organization.name}}
												<?php endif ?>
											</span>

											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteExpense">
											<organization-select name="organization" ng-model="self.editedLineFields.organization" form="posteExpenseForm"></organization-select>
											<field-errors field="organization" errors="self.errors.fields"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== posteExpense && posteExpense.id != 'total'">
											<span ng-if="posteExpense.destination">
												<?php if ($this->acl()->isAllowed('budget:e:destination:r')) : ?>
													<a href="<?= $this->url('budget/destination/form') ?>/{{posteExpense.destination.id}}">
														{{posteExpense.destination.code}} - {{posteExpense.destination.name}}
													</a>
												<?php else : ?>
													{{posteExpense.destination.code}} - {{posteExpense.destination.name}}
												<?php endif ?>
											</span>

											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteExpense">
											<destination-select name="destination" ng-model="self.editedLineFields.destination" form="posteExpenseForm"></destination-select>
											<field-errors field="destination" errors="self.errors.fields"></field-errors>
										</span>
									</td>
								<?php endif ?>


								<?php if ($this->acl()->isAllowed('budget:e:managementUnit:r')) : ?>
									<td></td>
								<?php endif ?>

								<td class="editable">
									<span ng-show="self.editedLine !== posteExpense">
										{{posteExpense.name}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteExpense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" />
										<field-errors field="name" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td>
									{{ posteExpense.project.name }}
								</td>

								<?php if ($this->module()->isActive('keyword')) : ?>
									<?php foreach ($groups as $group) : ?>
										<td class="editable">
											<span class="comma-separated" ng-show="self.editedLine !== posteExpense">
												<span ng-repeat="keyword in posteExpense.keywords[<?= $group->getId() ?>]">{{keyword.name}}</span>
												<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
											</span>
											<span ng-if="self.editedLine == posteExpense">
												<keyword-select ng-model="self.editedLineFields.keywords[<?= $group->getId() ?>]" multiple="<?= $group->isMultiple() ? 'true' : 'false' ?>" configuration="{ service : { apiParams : { search: { data: { filters: { group : { op: 'eq', val: <?= $group->getId() ?> } } } } } } }" form="posteExpenseForm"></keyword-select>
											</span>
										</td>
									<?php endforeach ?>
								<?php endif ?>

								<td class="editable text-right">
									<span ng-show="self.editedLine !== posteExpense">
										{{posteExpense.amount | currency : ''}} €
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
									</span>
									<span ng-if="self.editedLine == posteExpense">
										<input type="text" name="amount" class="form-control input-sm" autocomplete="off" input-mask="decimal" ng-model="self.editedLineFields.amount" />
										<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>

								<?php if ($ht) : ?>
									<td class="editable text-right">
										<span ng-show="self.editedLine !== posteExpense">
											{{posteExpense.amountHT | currency : ''}} €
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(posteExpense)', 'ng-if' => 'posteExpense._rights.update && !lockBudget']) ?>
										</span>
										<span ng-if="self.editedLine == posteExpense">
											<input type="text" name="amountHT" class="form-control input-sm" autocomplete="off" input-mask="decimal" ng-model="self.editedLineFields.amountHT" />
											<field-errors field="amountHT" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<td class="text-right">
									{{posteExpense.amountArbo | currency : ''}} €
								</td>

								<?php if ($ht) : ?>
									<td class="text-right">
										{{ posteExpense.amountHTArbo | currency : '' }} €
									</td>
								<?php endif ?>

								<td class="text-right">
									{{posteExpense.amountAggreg | currency : ''}} €
								</td>

								<?php if ($ht) : ?>
									<td class="text-right">
										{{ posteExpense.amountHTAggreg | currency : '' }} €
									</td>
								<?php endif ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (preg_match('/^ae/', $type)) : ?>
										<td class="text-right">
											{{posteExpense.amountArbo<?= ucfirst($type) ?> | currency : ''}} €
										</td>

										<?php if ($ht) : ?>
											<td class="text-right">
												{{posteExpense.amountHTArbo<?= ucfirst($type) ?> | currency : ''}} €
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (preg_match('/^ae/', $balance) && $balance !== 'aeCommittedCpCommittedBalance') : ?>
										<td class="text-right">
											{{posteExpense.amountArbo<?= ucfirst($balance) ?> | currency : ''}} <?= (preg_match('/Rate/', $balance) ? '%' : '€') ?>
										</td>

										<?php if ($ht) : ?>
											<td class="text-right">
												{{posteExpense.amountHTArbo<?= ucfirst($balance) ?> | currency : ''}} <?= (preg_match('/Rate/', $balance) ? '%' : '€') ?>
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (!preg_match('/^ae/', $type) && !preg_match('/^cp/', $type)) : ?>
										<td class="text-right">
											{{posteExpense.amountArbo<?= ucfirst($type) ?> | currency : ''}} €
										</td>

										<?php if ($ht) : ?>
											<td class="text-right">
												{{posteExpense.amountHTArbo<?= ucfirst($type) ?> | currency : ''}} €
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (!preg_match('/^ae/', $balance) && !preg_match('/^cp/', $balance)) : ?>
										<td class="text-right">
											{{posteExpense.amountArbo<?= ucfirst($balance) ?> | currency : ''}} €
										</td>

										<?php if ($ht) : ?>
											<td class="text-right">
												{{posteExpense.amountHTArbo<?= ucfirst($balance) ?> | currency : ''}} €
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (preg_match('/^cp/', $type)) : ?>
										<td class="text-right">
											{{posteExpense.amountArbo<?= ucfirst($type) ?> | currency : ''}} €
										</td>

										<?php if ($ht) : ?>
											<td class="text-right">
												{{posteExpense.amountHTArbo<?= ucfirst($type) ?> | currency : ''}} €
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (preg_match('/^cp/', $balance) || $balance === 'aeCommittedCpCommittedBalance') : ?>
										<td class="text-right">
											{{posteExpense.amountArbo<?= ucfirst($balance) ?> | currency : ''}} <?= (preg_match('/Rate/', $balance) ? '%' : '€') ?>
										</td>

										<?php if ($ht) : ?>
											<td class="text-right">
												{{posteExpense.amountHTArbo<?= ucfirst($balance) ?> | currency : ''}} <?= (preg_match('/Rate/', $balance) ? '%' : '€') ?>
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>
								<td></td>

								<?php if ($evolution) : ?>
									<td></td>
								<?php endif ?>

								<td>{{posteExpense.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>{{posteExpense.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine != posteExpense">
										<?php if ($this->acl()->isAllowed('budget:e:expense:c')) : ?>
											<a class="btn btn-xs btn-default" ng-click="self.createExpense(posteExpense);" ng-if="posteExpense.id != 'total' && !lockBudget && posteExpense._rights.update" tooltip="<?= $this->translate('expense_nav_form') ?>">
												<?= $this->icon('create') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:posteExpense:r')) : ?>
											<a ng-if="posteExpense._rights.read" class="btn btn-xs btn-default" ng-click="self.editPosteExpense(posteExpense);" tooltip="<?= $this->translate('tooltip_edit') ?>">
												<?= $this->icon('edit') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:posteExpense:d')) : ?>
											<a ng-if="posteExpense._rights.delete && !lockBudget" ng-click="self.deletePosteExpense(posteExpense);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
												<?= $this->icon('delete') ?>
											</a>
										<?php endif; ?>
									</div>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine == posteExpense">
										<button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(posteExpense, 'poste')" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
											<?= $this->icon('save') ?>
										</button>
										<button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
											<?= $this->icon('close') ?>
										</button>
									</div>
								</td>
							</tr>
							<tr ng-repeat="expense in posteExpense.expensesArbo" ng-show="showPoste" ng-class="{
									editing: self.editedLine == expense,
									dashed: expense.project.id !== self.from.id
								}">
								<td></td>

								<td>
									<?php if ($this->module()->isActive('age')) : ?>
										<i class="fa fa-cloud-upload" ng-if="expense.age" tooltip="Importé via AGE"></i>
									<?php endif; ?>
								</td>

								<td>
									<span ng-show="self.groupBy !== 'poste'">
										{{ expense.account.code ? expense.account.code + ' -' : '' }}
										{{ expense.account.name }}
									</span>
								</td>

								<?php if ($gbcp) : ?>
									<td>
										<span ng-show="self.groupBy !== 'poste'">
											{{ expense.nature.code ? expense.nature.code + ' -' : '' }}
											{{ expense.nature.name }}
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td>
										<span ng-show="self.groupBy !== 'poste'">
											{{ expense.organization.code ? expense.organization.code + ' -' : '' }}
											{{ expense.organization.name }}
										</span>
									</td>
								<?php endif ?>

								<?php if ($gbcp) : ?>
									<td>
										<span ng-show="self.groupBy !== 'poste'">
											{{ expense.destination.code ? expense.destination.code + ' -' : '' }}
											{{ expense.destination.name }}
										</span>
									</td>
								<?php endif ?>

								<?php if ($this->acl()->isAllowed('budget:e:managementUnit:r')) : ?>
									<td>
										{{ expense.managementUnit.code ? expense.managementUnit.code + ' -' : '' }}
										{{ expense.managementUnit.name }}
									</td>
								<?php endif ?>

								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.name}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" />
										<field-errors field="name" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>

								<td>
									<?php if ($this->acl()->isAllowed('project:e:project:r')) : ?>
										<a href="<?= $this->url('project/form') ?>/{{expense.project.id}}">{{expense.project.name}}</a>
									<?php else : ?>
										{{expense.project.name}}
									<?php endif ?>
								</td>

								<?php if ($this->module()->isActive('keyword')) : ?>
									<?php foreach ($groups as $group) : ?>
										<td></td>
									<?php endforeach ?>
								<?php endif ?>

								<td></td>
								<td></td>
								<td></td>

								<?php if ($ht) : ?>
									<td></td>
									<td></td>
									<td></td>
								<?php endif ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (preg_match('/^ae/', $type)) : ?>
										<td class="editable text-right">
											<span ng-show="self.editedLine !== expense">
												{{expense.type == '<?= $type ?>' ? (expense.amount | currency : '') + ' €' : '' }}
												<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => 'expense.type == \'' . $type . '\' && !lockBudget && expense._rights.update']) ?>
											</span>
											<span ng-if="self.editedLine == expense && expense.type == '<?= $type ?>'">
												<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amount" required input-mask="decimal" />
												<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
											</span>
										</td>

										<?php if ($ht) : ?>
											<td class="editable text-right">
												<span ng-show="self.editedLine !== expense">
													{{expense.type == '<?= $type ?>' ? (expense.amountHT | currency : '') + ' €' : '' }}
													<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => 'expense.type == \'' . $type . '\' && !lockBudget && expense._rights.update']) ?>
												</span>
												<span ng-if="self.editedLine == expense && expense.type == '<?= $type ?>'">
													<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amountHT" required input-mask="decimal" />
													<field-errors field="amountHT" errors="self.editedLineErrors"></field-errors>
												</span>
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (preg_match('/^ae/', $balance) && $balance !== 'aeCommittedCpCommittedBalance') : ?>
										<td></td>

										<?php if ($ht) : ?>
											<td></td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach; ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (!preg_match('/^ae/', $type) && !preg_match('/^cp/', $type)) : ?>
										<td class="editable text-right">
											<span ng-show="self.editedLine !== expense">
												{{expense.type == '<?= $type ?>' ? (expense.amount | currency : '') + ' €' : '' }}
												<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => 'expense.type == \'' . $type . '\' && !lockBudget && expense._rights.update']) ?>
											</span>
											<span ng-if="self.editedLine == expense && expense.type == '<?= $type ?>'">
												<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amount" required input-mask="decimal" />
												<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
											</span>
										</td>

										<?php if ($ht) : ?>
											<td class="editable text-right">
												<span ng-show="self.editedLine !== expense">
													{{expense.type == '<?= $type ?>' ? (expense.amountHT | currency : '') + ' €' : '' }}
													<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => 'expense.type == \'' . $type . '\' && !lockBudget && expense._rights.update']) ?>
												</span>
												<span ng-if="self.editedLine == expense && expense.type == '<?= $type ?>'">
													<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amountHT" required input-mask="decimal" />
													<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
												</span>
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (!preg_match('/^ae/', $balance) && !preg_match('/^cp/', $balance)) : ?>
										<td></td>

										<?php if ($ht) : ?>
											<td></td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach; ?>

								<?php foreach ($expenseTypes as $type) : ?>
									<?php if (preg_match('/^cp/', $type)) : ?>
										<td class="editable text-right">
											<span ng-show="self.editedLine !== expense">
												{{expense.type == '<?= $type ?>' ? (expense.amount | currency : '') + ' €' : '' }}
												<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => 'expense.type == \'' . $type . '\' && !lockBudget && expense._rights.update']) ?>
											</span>
											<span ng-if="self.editedLine == expense && expense.type == '<?= $type ?>'">
												<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amount" required input-mask="decimal" />
												<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
											</span>
										</td>

										<?php if ($ht) : ?>
											<td class="editable text-right">
												<span ng-show="self.editedLine !== expense">
													{{expense.type == '<?= $type ?>' ? (expense.amountHT | currency : '') + ' €' : '' }}
													<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => 'expense.type == \'' . $type . '\' && !lockBudget && expense._rights.update']) ?>
												</span>
												<span ng-if="self.editedLine == expense && expense.type == '<?= $type ?>'">
													<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.amountHT" required input-mask="decimal" />
													<field-errors field="amount" errors="self.editedLineErrors"></field-errors>
												</span>
											</td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach ?>

								<?php foreach ($posteExpenseBalances as $balance) : ?>
									<?php if (preg_match('/^cp/', $balance) || $balance === 'aeCommittedCpCommittedBalance') : ?>
										<td></td>

										<?php if ($ht) : ?>
											<td></td>
										<?php endif ?>
									<?php endif; ?>
								<?php endforeach; ?>

								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.tiers}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.tiers" />
										<field-errors field="tiers" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.anneeExercice}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.anneeExercice" />
										<field-errors field="anneeExercice" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.bordereau}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.bordereau" />
										<field-errors field="bordereau" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.mandat}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.mandat" />
										<field-errors field="mandat" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.engagement}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.engagement" />
										<field-errors field="engagement" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.complement}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.complement" />
										<field-errors field="complement" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.dateFacture | dateFormat : 'DD/MM/YYYY'}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.dateFacture" input-mask="qdate" />
										<field-errors field="dateFacture" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== expense">
										{{expense.date | dateFormat : 'DD/MM/YYYY'}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(expense)', 'ng-if' => '!lockBudget && expense._rights.update']) ?>
									</span>
									<span ng-if="self.editedLine == expense">
										<input type="text" class="form-control input-sm" ng-model="self.editedLineFields.date" required input-mask="qdate" />
										<field-errors field="date" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>

								<?php if ($evolution) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== expense">
											{{ expense.evolution ? 'Oui' : 'Non' }}

											<?= $this->icon('inline-edit', '', [
												'ng-click' => 'self.editLine(expense)',
												'ng-if' => '!lockBudget && expense._rights.update'
											]) ?>
										</span>

										<span ng-if="self.editedLine == expense">
											<input type="checkbox" class="form-control input-sm" ng-model="self.editedLineFields.evolution" />
											<field-errors field="evolution" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
								<?php endif ?>

								<td>{{expense.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>{{expense.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td class="text-right">
									<div class="btn-group btn-group-actions" ng-if="self.editedLine != expense">
										<?php if ($this->acl()->isAllowed('budget:e:expense:u')) : ?>
											<a class="btn btn-xs btn-default" ng-click="self.editExpense(expense, posteExpense);" tooltip="<?= $this->translate('tooltip_edit') ?>">
												<?= $this->icon('edit') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:expense:c')) : ?>
											<a class="btn btn-xs btn-default" ng-click="self.duplicateExpense(expense, posteExpense)" tooltip="<?= $this->translate('tooltip_copy') ?>">
												<?= $this->icon('duplicate') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('budget:e:expense:d')) : ?>
											<a ng-click="self.deleteExpense(expense, posteExpense);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-if="!lockBudget && expense._rights.update">
												<?= $this->icon('delete') ?>
											</a>
										<?php endif; ?>
									</div>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine == expense">
										<button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(expense, 'expense', posteExpense)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
											<?= $this->icon('save') ?>
										</button>
										<button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
											<?= $this->icon('close') ?>
										</button>
									</div>
								</td>
							</tr>
						</tbody>
					</table>
				</form>
			</div>
		</div>
	</table-builder>
	<?= $this->partial('budget/partial/poste-expense/form.phtml', ['from' => $this->from, 'object' => $this->object]) ?>
	<?= $this->partial('budget/partial/poste-expense/simplified-input.phtml'); ?>
	<?= $this->partial('budget/partial/expense/form.phtml', ['from' => $this->from, 'object' => $this->object]) ?>

	<div class="modal" id="exportExcelModal3">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<h4 class="modal-title"><?= $this->translate('project_exportExcel_module_title') ?></h4>
				</div>
				<div class="modal-body">
					<div class="row">
						<div class="col-xs-12">
							<select class="form-control" ng-model="self.exportModel">
								<option value="default"><?= $this->translate('project_export_default') ?></option>
								<?php if (count($this->expenseCustomExportsExcel) > 0) : ?>
									<optgroup label="<?= ucfirst($this->translate('export_custom_entity')) ?>">

										<?php foreach ($this->expenseCustomExportsExcel as $export) : ?>
											<option value="<?= $export->getKey() ?>">
												<?= $export->getName() ?>
											</option>
										<?php endforeach; ?>

									</optgroup>
								<?php endif; ?>
							</select>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button class="btn btn-default" type="button" data-dismiss="modal">
						<?= $this->translate('close') ?>
					</button>

					<button class="btn btn-submit" ng-disabled="self.loading.export || !self.exportModel" ng-click="self.export('<?= ucfirst(\Export\Entity\Export::TYPE_EXCEL) ?>')">
						<?= $this->icon('loading', '', ['ng-if' => 'self.loading.export']) ?>
						<?= $this->translate('export') ?>
					</button>

					<form id="exportExcelForm3" action="<?= $this->url('project/tree') ?>" method="POST" target="_blank">
						<input type="hidden" name="export" value="{{self.exportModel}}" />
						<input type="hidden" name="filters" value="{{self.exportFilters}}" />
					</form>
				</div>
			</div>
		</div>
	</div>
</div>